diff -urN linux.store/linux/arch/arm/drivers/char/console.c linux/arch/arm/drivers/char/console.c
--- linux.store/linux/arch/arm/drivers/char/console.c	Sun Mar  3 12:31:06 1996
+++ linux/arch/arm/drivers/char/console.c	Mon Mar 11 22:31:14 1996
@@ -70,8 +70,7 @@
 /* ARM Extensions */
 extern void memc_write (int reg, int val);
 extern void vidc_write (int reg, int val);
-extern void ll_char_write(unsigned long ps, int ch, unsigned char forec,
-			 unsigned char backc, unsigned char flgs);
+extern void ll_write_char(unsigned long ps, unsigned long chinfo);
 extern void memfastset (void *ptr, unsigned long word, int length);
 extern void prints (const char *, ...);
 extern void map_screen_mem (unsigned long vid_base, int remap);
@@ -445,12 +444,12 @@
 
   flgs=FLAGS;
 
-  if(currcons == fg_console)
-    ll_char_write(ps, ch, forecol, backcol, flgs);
-
   index = (x + y * video_num_columns);
 
   buffer[index] = (flgs<<24)|(backcol<<16)|(forecol<<8)|ch;
+
+  if (currcons == fg_console)
+    ll_write_char(ps, buffer[index]);
 }
 
 static char cursor_on=0;
@@ -460,8 +459,7 @@
 {
   unsigned long flags;
 
-  save_flags(flags);
-  cli();
+  save_flags_cli (flags);
   if(--cursoron==0 && currcons == fg_console)
     put_cursor(0, cp);
   restore_flags(flags);
@@ -471,8 +469,7 @@
 {
   unsigned long flags;
 
-  save_flags(flags);
-  cli();
+  save_flags_cli (flags);
   if(++cursoron==1 && cursor_on && currcons == fg_console)
     put_cursor(1,cp);
   restore_flags(flags);
@@ -604,7 +601,7 @@
 {
   unsigned long flags;
   clear_selection();
-  save_flags(flags); cli();
+  save_flags_cli (flags);
   __origin = offset;
 
   memc_write(0,offset>>2);
@@ -647,8 +644,7 @@
 
 	if(__real_origin != __origin)
 		__set_origin(__real_origin);
-	save_flags(flags);
-	cli();
+	save_flags_cli (flags);
 
 	if(deccm)
 		cp = pos + video_num_columns * bytes_per_char_h * (bytes_per_char_v - 1);
@@ -1962,21 +1958,18 @@
 	console_driver.throttle = con_throttle;
 	console_driver.unthrottle = con_unthrottle;
 
-	if(tty_register_driver(&console_driver))
+	if (tty_register_driver(&console_driver))
 	  	panic("Couldn't register console driver\n");
 
 	con_setsize(ORIG_VIDEO_LINES,ORIG_VIDEO_COLS);
 
 	timer_table[BLANK_TIMER].fn=blank_screen;
 	timer_table[BLANK_TIMER].expires=0;
-	if(blankinterval) {
+	if (blankinterval) {
   		timer_table[BLANK_TIMER].expires=jiffies+blankinterval;
 		timer_active|=1<<BLANK_TIMER;
 	}
 
-	for(i=0; i<17; i++)
-		vidc_write(i<<2, default_palette_entries[i]);
-
 	/* Use ORIG_VIDEO_MODE */
 	video_addr_mask= (video_num_lines * video_num_columns * bytes_per_char_h *
 				 bytes_per_char_v - 1) | (PAGE_SIZE-1);
@@ -1986,13 +1979,15 @@
 	map_screen_mem (video_mem_base, 1);
 
 	can_do_color=1;
-	if(bytes_per_char_h == 8)
-	{
+	if (bytes_per_char_h == 8) {
 		default_palette_entries = palette_8;
 		color_table = color_8;
 	}
 
-	for(currcons = 0; currcons < MIN_NR_CONSOLES; currcons++) {
+	for (i = 0; i < 17; i++)
+		vidc_write (i << 2, default_palette_entries[i]);
+
+	for (currcons = 0; currcons < MIN_NR_CONSOLES; currcons++) {
 		vc_cons[currcons].d = (struct vc_data *) kmem_start;
 		kmem_start += sizeof(struct vc_data);
 		vt_cons[currcons] = (struct vt_struct *) kmem_start;
@@ -2024,7 +2019,7 @@
   		(MIN_NR_CONSOLES == 1) ? "":"s",
   		MAX_NR_CONSOLES);
 	register_console (console_print);
-	if(request_irq (IRQ_VSYNCPULSE, vsync_irq, 0, "console"))
+	if (request_irq (IRQ_VSYNCPULSE, vsync_irq, 0, "console"))
 		panic ("Unable to get VSYNC irq for console\n");
 	return kmem_start;
 }
@@ -2057,8 +2052,7 @@
 			pp = p + sx * bytes_per_char_h;
 			for (; sx < video_num_columns; sx++)
 			{
-				ll_char_write (pp, buffer[0] & 0xff, (buffer[0] >> 8) & 0xff,
-					(buffer[0] >> 16) & 0xff, (buffer[0] >> 24) & 0xff);
+				ll_write_char (pp, *buffer);
 				pp += bytes_per_char_h;
 				buffer ++;
 			}
@@ -2070,8 +2064,7 @@
 	{
 		for (; sx < ex; sx++)
 		{
-			ll_char_write (p, buffer[0] & 0xff, (buffer[0] >> 8) & 0xff,
-				(buffer[0] >> 16) & 0xff, (buffer[0] >> 24) & 0xff);
+			ll_write_char (p, *buffer);
 			p += bytes_per_char_h;
 			buffer ++;
 		}
@@ -2080,37 +2073,35 @@
 
 void set_scrmem(int currcons,long offset)
 {
-	unsigned long p,pp,mx,my;
+	unsigned long p, pp, my, by;
 	unsigned long *buffer;
 	int i;
 
 	p = origin;
 	buffer = (unsigned long *)vc_scrbuf[currcons];
 
-	for(my = 0; my < video_num_lines ; my++)
-	{
+	by = video_size_row;
+	for (my = video_num_lines; my > 0; my--) {
+		int mx, bx = bytes_per_char_h;
 		pp = p;
-		for(mx = 0; mx < video_num_columns; mx++)
-		{
-			ll_char_write(pp,buffer[0] & 0xff,(buffer[0] >> 8) & 0xff,
-					 (buffer[0] >> 16) & 0xff,(buffer[0] >> 24) & 0xff);
-			pp+=bytes_per_char_h;
-			buffer+=1;
+		for (mx = video_num_columns; mx > 0; mx--) {
+			ll_write_char (pp, *buffer);
+			pp += bx;
+			buffer += 1;
 		}
-		p+=video_size_row;
+		p += by;
 	}
 	pp = origin + ((video_screen_size + 0x7FFF) & PAGE_MASK);
-	while(p<pp)
-	{
-		*(unsigned long *)p=0;
-		p+=4;
-	}
-	if(!paletteentries || vcmode != KD_GRAPHICS)
-		for(i=0; i<17; i++)
-			vidc_write(i<<2, default_palette_entries[i]);
+	while (p < pp) {
+		*(unsigned long *)p = 0;
+		p += 4;
+	}
+	if (!paletteentries || vcmode != KD_GRAPHICS)
+		for (i = 0; i < 17; i++)
+			vidc_write(i << 2, default_palette_entries[i]);
 	else
-		for(i=0; i<17; i++)
-			vidc_write(i<<2, paletteentries[i] & 0x1fff);
+		for (i = 0; i < 17; i++)
+			vidc_write(i << 2, paletteentries[i] & 0x1fff);
 }
 
 /* ------------------------------------------------------------------------------------- *
@@ -2408,9 +2399,9 @@
 			pp = p + (hx * bytes_per_char_h);
 			for(mx = hx; mx < ((my == hey)?hex+1:video_num_columns); mx++)
 			{
-				ll_char_write(pp,buffer[0],buffer[1],buffer[2],buffer[3]);
-				pp+=bytes_per_char_h;
-				buffer+=4;
+				ll_write_char (pp, *(unsigned long *)buffer);
+				pp += bytes_per_char_h;
+				buffer += 4;
 				hx = 0;
 			}
 			p+=video_size_row;
diff -urN linux.store/linux/arch/arm/drivers/char/kbdmouse.c linux/arch/arm/drivers/char/kbdmouse.c
--- linux.store/linux/arch/arm/drivers/char/kbdmouse.c	Sun Mar  3 12:39:09 1996
+++ linux/arch/arm/drivers/char/kbdmouse.c	Mon Mar 11 22:32:06 1996
@@ -67,8 +67,7 @@
     if (mouse_active++)
 	return 0;
 
-    save_flags (flags);
-    cli ();
+    save_flags_cli (flags);
     mouse_active  = 1;
     mouse_ready   = 0;
     mouse_dxpos   = 0;
@@ -98,8 +97,7 @@
     if (!mouse_ready)
 	return -EAGAIN;
 
-    save_flags (flags);
-    cli ();
+    save_flags_cli (flags);
 
     dxpos = mouse_dxpos;
     dypos = mouse_dypos;
@@ -162,8 +160,7 @@
 {
     unsigned long flags;
 
-    save_flags (flags);
-    cli ();
+    save_flags_cli (flags);
 
     mouse_buttons=0;
     mouse_dxpos  =0;
diff -urN linux.store/linux/arch/arm/drivers/char/keyboard.c linux/arch/arm/drivers/char/keyboard.c
--- linux.store/linux/arch/arm/drivers/char/keyboard.c	Sun Mar  3 12:39:34 1996
+++ linux/arch/arm/drivers/char/keyboard.c	Mon Mar 11 22:32:27 1996
@@ -1219,17 +1219,18 @@
     tty = ttytab[fg_console];
     kbd = kbd_table + fg_console;
 
-    if (rep && kbd_repeatkey != -1) {
-    	/*
-    	 * This prevents the kbd_key routine from being called
-    	 * twice, once by this BH, and once by the interrupt
-    	 * routine.  Maybe we should put the key press in a
-    	 * buffer or variable, and then call the BH...
-    	 */
+    if (rep) {
+	/*
+	 * This prevents the kbd_key routine from being called
+	 * twice, once by this BH, and once by the interrupt
+	 * routine.  Maybe we should put the key press in a
+	 * buffer or variable, and then call the BH...
+	 */
     	disable_irq (IRQ_KEYBOARDRX);
-	kbd_key (kbd_repeatkey, kbd_repeatrate);
+	if (kbd_repeatkey != -1)
+	    kbd_key (kbd_repeatkey, kbd_repeatrate);
 	enable_irq (IRQ_KEYBOARDRX);
-        rep = 0;
+	rep = 0;
     }
 
     if(want_console >= 0) {
@@ -1250,8 +1251,7 @@
 	leds = ((leds & (1<<VC_SCROLLOCK))?4:0) | ((leds & (1<<VC_NUMLOCK))?2:0) |
 	       ((leds & (1<<VC_CAPSLOCK))?1:0);
 
-	save_flags(flags);
-	cli();
+	save_flags_cli (flags);
 	intr_count -= 1;
 
 	kbd_sendval(leds);
@@ -1283,8 +1283,7 @@
 
     bh_base[KEYBOARD_BH].routine = kbd_bh;
 
-    save_flags (flags);
-    cli ();
+    save_flags_cli (flags);
     if (request_irq (IRQ_KEYBOARDRX, kbd_rx, 0, "keyboard")!=0)
 	panic("Could not allocate keyboard receive IRQ!");
     if (request_irq (IRQ_KEYBOARDTX, kbd_tx, 0, "Keyboard")!=0)
diff -urN linux.store/linux/arch/arm/drivers/char/serial.c linux/arch/arm/drivers/char/serial.c
--- linux.store/linux/arch/arm/drivers/char/serial.c	Sun Mar  3 12:47:09 1996
+++ linux/arch/arm/drivers/char/serial.c	Mon Mar 11 22:34:23 1996
@@ -242,7 +242,7 @@
 	if (serial_paranoia_check(info, tty->device, "rs_stop"))
 		return;
 	
-	save_flags(flags); cli();
+	save_flags_cli (flags);
 	if (info->IER & UART_IER_THRI) {
 		info->IER &= ~UART_IER_THRI;
 		serial_out(info, UART_IER, info->IER);
@@ -258,7 +258,7 @@
 	if (serial_paranoia_check(info, tty->device, "rs_start"))
 		return;
 	
-	save_flags(flags); cli();
+	save_flags_cli (flags);
 	if (info->xmit_cnt && info->xmit_buf && !(info->IER & UART_IER_THRI)) {
 		info->IER |= UART_IER_THRI;
 		serial_out(info, UART_IER, info->IER);
@@ -344,7 +344,6 @@
 	ignore_char:
 		*status = serial_inp(info, UART_LSR) & info->read_status_mask;
 	} while (*status & UART_LSR_DR);
-{ unsigned long flags; save_flags (flags); if (!(flags & 0x08000000)) printk ("SERIAL IRQ ON!\n"); }
 	queue_task_irq_off(&tty->flip.tqueue, &tq_timer);
 #ifdef SERIAL_DEBUG_INTR
 	printk("DR...");
@@ -831,7 +830,7 @@
 			return -ENOMEM;
 	}
 
-	save_flags(flags); cli();
+	save_flags_cli (flags);
 
 #ifdef SERIAL_DEBUG_OPEN
 	printk("starting up ttys%d (irq %d)...", info->line, info->irq);
@@ -989,7 +988,7 @@
 	       info->irq);
 #endif
 	
-	save_flags(flags); cli(); /* Disable interrupts */
+	save_flags_cli (flags); /* Disable interrupts */
 	
 	/*
 	 * First unlink the serial port from the IRQ chain...
@@ -1204,7 +1203,7 @@
 	if (!tty || !info->xmit_buf)
 		return;
 
-	save_flags(flags); cli();
+	save_flags_cli (flags);
 	if (info->xmit_cnt >= SERIAL_XMIT_SIZE - 1) {
 		restore_flags(flags);
 		return;
@@ -1228,7 +1227,7 @@
 	    !info->xmit_buf)
 		return;
 
-	save_flags(flags); cli();
+	save_flags_cli (flags);
 	info->IER |= UART_IER_THRI;
 	serial_out(info, UART_IER, info->IER);
 	restore_flags(flags);
@@ -1247,7 +1246,7 @@
 	if (!tty || !info->xmit_buf || !tmp_buf)
 		return 0;
 	    
-	save_flags(flags);
+	save_flags_cli (flags);
 	while (1) {
 		cli();		
 		c = MIN(count, MIN(SERIAL_XMIT_SIZE - info->xmit_cnt - 1,
@@ -1945,7 +1944,7 @@
 	if (!info || serial_paranoia_check(info, tty->device, "rs_close"))
 		return;
 	
-	save_flags(flags); cli();
+	save_flags_cli (flags);
 	
 	if (tty_hung_up_p(filp)) {
 		restore_flags(flags);
@@ -2400,7 +2399,7 @@
 	if (!port)
 		return;
 
-	save_flags(flags); cli();
+	save_flags_cli (flags);
 	
 	/*
 	 * Do a simple existence test first; if we fail this, there's
@@ -2651,8 +2650,7 @@
 	unsigned long flags;
 	struct async_struct *info;
 
-	save_flags(flags);
-	cli();
+	save_flags_cli (flags);
 	for (i = 0; i < NR_PORTS; i++) {
 		if (rs_table[i].port == req->port)
 			break;
@@ -2705,8 +2703,7 @@
 	unsigned long flags;
 	struct async_struct *info = &rs_table[line];
 
-	save_flags(flags);
-	cli();
+	save_flags_cli (flags);
 	if (info->tty)
 		tty_hangup(info->tty);
 	info->type = PORT_UNKNOWN;
diff -urN linux.store/linux/arch/arm/drivers/char/serial6850.c linux/arch/arm/drivers/char/serial6850.c
--- linux.store/linux/arch/arm/drivers/char/serial6850.c	Thu Jan  1 01:00:00 1970
+++ linux/arch/arm/drivers/char/serial6850.c	Mon Mar 11 21:32:33 1996
@@ -0,0 +1,23 @@
+/*
+ * Dummy serial functions
+ *
+ * Copyright (C) 1995, 1996 Russell King
+ */
+
+#include <linux/errno.h>
+#include <linux/sched.h>
+#include <linux/serial.h>
+
+int rs_init (void)
+{
+    return 0;
+}
+
+int register_serial (struct serial_struct *dev)
+{
+    return -1;
+}
+
+void unregister_serial (int line)
+{
+}
diff -urN linux.store/linux/arch/arm/drivers/char/tty_io.c linux/arch/arm/drivers/char/tty_io.c
--- linux.store/linux/arch/arm/drivers/char/tty_io.c	Sun Mar  3 12:48:37 1996
+++ linux/arch/arm/drivers/char/tty_io.c	Mon Mar 11 23:57:46 1996
@@ -1252,8 +1252,7 @@
 			return -ENOMEM;
 		fa->magic = FASYNC_MAGIC;
 		fa->fa_file = filp;
-		save_flags(flags);
-		cli();
+		save_flags_cli (flags);
 		fa->fa_next = *fapp;
 		*fapp = fa;
 		restore_flags(flags);
@@ -1261,8 +1260,7 @@
 	}
 	if (!fa)
 		return 0;
-	save_flags(flags);
-	cli();
+	save_flags_cli (flags);
 	*fp = fa->fa_next;
 	restore_flags(flags);
 	kfree(fa);
diff -urN linux.store/linux/arch/arm/drivers/char/vc_screen.c linux/arch/arm/drivers/char/vc_screen.c
--- linux.store/linux/arch/arm/drivers/char/vc_screen.c	Sat Feb 24 18:12:00 1996
+++ linux/arch/arm/drivers/char/vc_screen.c	Sun Mar 10 15:26:14 1996
@@ -163,7 +163,7 @@
 		org = screen_pos(cons, p);
 		while (count-- > 0) {
 			*org = (*org & 0xffffff00) | get_fs_byte(buf++);
-			ll_char_write (*org);
+/*			ll_write_char (,*org);*/
 			org++;
 		}
 	} else {
diff -urN linux.store/linux/arch/arm/drivers/net/ether1.c linux/arch/arm/drivers/net/ether1.c
--- linux.store/linux/arch/arm/drivers/net/ether1.c	Sun Feb 18 09:28:09 1996
+++ linux/arch/arm/drivers/net/ether1.c	Mon Mar 11 22:34:57 1996
@@ -72,22 +72,41 @@
 static int ether1_manus[] = { 0x0000 };
 
 /* ------------------------------------------------------------------------- */
-#define ether1_inw(dev, addr, type, offset) ether1_inw_p (dev, addr + (int)(&((type *)0)->offset))
-#define ether1_outw(dev, val, addr, type, offset) ether1_outw_p (dev, val, addr + (int)(&((type *)0)->offset))
+
+#define DISABLEIRQS 1
+#define NORMALIRQS  0
+
+#define ether1_inw(dev, addr, type, offset, svflgs) ether1_inw_p (dev, addr + (int)(&((type *)0)->offset), svflgs)
+#define ether1_outw(dev, val, addr, type, offset, svflgs) ether1_outw_p (dev, val, addr + (int)(&((type *)0)->offset), svflgs)
 
 static inline unsigned short
-ether1_inw_p (struct device *dev, int addr)
+ether1_inw_p (struct device *dev, int addr, int svflgs)
 {
-    outb (addr >> 12, REG_PAGE);
+    unsigned long flags;
+    unsigned short ret;
 
-    return inw (ETHER1_RAM + ((addr & 4095) >> 1));
+    if (svflgs) {
+	save_flags_cli (flags);
+    }
+    outb (addr >> 12, REG_PAGE);
+    ret = inw (ETHER1_RAM + ((addr & 4095) >> 1));
+    if (svflgs)
+	restore_flags (flags);
+    return ret;
 }
 
 static inline void
-ether1_outw_p (struct device *dev, unsigned short val, int addr)
+ether1_outw_p (struct device *dev, unsigned short val, int addr, int svflgs)
 {
+    unsigned long flags;
+
+    if (svflgs) {
+	save_flags_cli (flags);
+    }
     outb (addr >> 12, REG_PAGE);
     outw (val, ETHER1_RAM + ((addr & 4095) >> 1));
+    if (svflgs)
+	restore_flags (flags);
 }
 
 static inline void *
@@ -423,7 +442,7 @@
 
     /* 586 should now unset iscp.busy */
     i = jiffies + HZ/2;
-    while (ether1_inw (dev, ISCP_ADDR, iscp_t, iscp_busy) == 1) {
+    while (ether1_inw (dev, ISCP_ADDR, iscp_t, iscp_busy, DISABLEIRQS) == 1) {
 	if (jiffies > i) {
 	    printk ("%s: can't initialise 82586: iscp is busy\n", dev->name);
 	    return 1;
@@ -432,7 +451,8 @@
 
     /* check status of commands that we issued */
     i += HZ/10;
-    while (((status = ether1_inw (dev, CFG_ADDR, cfg_t, cfg_status)) & STAT_COMPLETE) == 0) {
+    while (((status = ether1_inw (dev, CFG_ADDR, cfg_t, cfg_status, DISABLEIRQS))
+		& STAT_COMPLETE) == 0) {
 	if (jiffies > i)
 	    break;
     }
@@ -444,7 +464,8 @@
     }
 
     i += HZ/10;
-    while (((status = ether1_inw (dev, SA_ADDR, sa_t, sa_status)) & STAT_COMPLETE) == 0) {
+    while (((status = ether1_inw (dev, SA_ADDR, sa_t, sa_status, DISABLEIRQS))
+		& STAT_COMPLETE) == 0) {
 	if (jiffies > i)
 	    break;
     }
@@ -456,7 +477,8 @@
     }
 
     i += HZ/10;
-    while (((status = ether1_inw (dev, MC_ADDR, mc_t, mc_status)) & STAT_COMPLETE) == 0) {
+    while (((status = ether1_inw (dev, MC_ADDR, mc_t, mc_status, DISABLEIRQS))
+		& STAT_COMPLETE) == 0) {
 	if (jiffies > i)
 	    break;
     }
@@ -468,7 +490,8 @@
     }
 
     i += HZ;
-    while (((status = ether1_inw (dev, TDR_ADDR, tdr_t, tdr_status)) & STAT_COMPLETE) == 0) {
+    while (((status = ether1_inw (dev, TDR_ADDR, tdr_t, tdr_status, DISABLE_IRQS))
+		& STAT_COMPLETE) == 0) {
 	if (jiffies > i)
 	    break;
     }
@@ -478,7 +501,7 @@
 	return 0;
     }
 
-    status = ether1_inw (dev, TDR_ADDR, tdr_t, tdr_result);
+    status = ether1_inw (dev, TDR_ADDR, tdr_t, tdr_result, DISABLEIRQS);
     if (status & TDR_XCVRPROB)
 	printk ("%s: i/f failed tdr: transceiver problem\n", dev->name);
     else
@@ -680,6 +703,7 @@
     else {
 	int len = (ETH_ZLEN < skb->len) ? skb->len : ETH_ZLEN;
 	int tmp, tst, nopaddr, txaddr, tbdaddr, dataddr;
+	unsigned long flags;
 	tx_t tx;
 	tbd_t tbd;
 	nop_t nop;
@@ -703,15 +727,17 @@
 	nop.nop_command = CMD_NOP;
 	nop.nop_link = nopaddr;
 
+	save_flags_cli (flags);
 	ether1_writebuffer (dev, &tx, txaddr, TX_SIZE);
 	ether1_writebuffer (dev, &tbd, tbdaddr, TBD_SIZE);
 	ether1_writebuffer (dev, skb->data, dataddr, len);
 	ether1_writebuffer (dev, &nop, nopaddr, NOP_SIZE);
 	tmp = priv->tx_link;
 	priv->tx_link = nopaddr;
+	restore_flags (flags);
 
 	/* now reset the previous nop pointer */
-	ether1_outw (dev, txaddr, tmp, nop_t, nop_link);
+	ether1_outw (dev, txaddr, tmp, nop_t, nop_link, DISABLEIRQS);
 
 	/* handle transmit */
 	dev->trans_start = jiffies;
@@ -743,8 +769,10 @@
     switch (nop.nop_command & CMD_MASK) {
     case CMD_TDR:
 	/* special case */
-	if (ether1_inw (dev, SCB_ADDR, scb_t, scb_cbl_offset) != (unsigned short)I82586_NULL) {
-	    ether1_outw (dev, SCB_CMDCUCSTART | SCB_CMDRXSTART, SCB_ADDR, scb_t, scb_command);
+	if (ether1_inw (dev, SCB_ADDR, scb_t, scb_cbl_offset, NORMALIRQS)
+				!= (unsigned short)I82586_NULL) {
+	    ether1_outw (dev, SCB_CMDCUCSTART | SCB_CMDRXSTART, SCB_ADDR, scb_t,
+		scb_command, NORMALIRQS);
 	    outb (CTRL_CA, REG_CONTROL);
 	}
 	priv->tx_tail = NOP_ADDR;
@@ -838,11 +866,11 @@
     rbd_t rbd;
 
     do {
-	status = ether1_inw (dev, priv->rx_head, rfd_t, rfd_status);
+	status = ether1_inw (dev, priv->rx_head, rfd_t, rfd_status, NORMALIRQS);
 	if ((status & RFD_COMPLETE) == 0)
 	    break;
 
-	rbdaddr = ether1_inw (dev, priv->rx_head, rfd_t, rfd_rbdoffset);
+	rbdaddr = ether1_inw (dev, priv->rx_head, rfd_t, rfd_rbdoffset, NORMALIRQS);
 	ether1_readbuffer (dev, &rbd, rbdaddr, RBD_SIZE);
 
 	if ((rbd.rbd_status & (RBD_EOF | RBD_ACNTVALID)) == (RBD_EOF | RBD_ACNTVALID)) {
@@ -869,18 +897,18 @@
 	    priv->stats.rx_dropped ++;
 	}
 
-	nexttail = ether1_inw (dev, priv->rx_tail, rfd_t, rfd_link);
+	nexttail = ether1_inw (dev, priv->rx_tail, rfd_t, rfd_link, NORMALIRQS);
 	/* nexttail should be rx_head */
 	if (nexttail != priv->rx_head)
 	    printk ("%s: receiver buffer chaining error (%04X != %04X)\n", dev->name, nexttail,
 			priv->rx_head);
-	ether1_outw (dev, RFD_CMDEL | RFD_CMDSUSPEND, nexttail, rfd_t, rfd_command);
-	ether1_outw (dev, 0, priv->rx_tail, rfd_t, rfd_command);
-	ether1_outw (dev, 0, priv->rx_tail, rfd_t, rfd_status);
-	ether1_outw (dev, 0, priv->rx_tail, rfd_t, rfd_rbdoffset);
+	ether1_outw (dev, RFD_CMDEL | RFD_CMDSUSPEND, nexttail, rfd_t, rfd_command, NORMALIRQS);
+	ether1_outw (dev, 0, priv->rx_tail, rfd_t, rfd_command, NORMALIRQS);
+	ether1_outw (dev, 0, priv->rx_tail, rfd_t, rfd_status, NORMALIRQS);
+	ether1_outw (dev, 0, priv->rx_tail, rfd_t, rfd_rbdoffset, NORMALIRQS);
 	
 	priv->rx_tail = nexttail;
-	priv->rx_head = ether1_inw (dev, priv->rx_head, rfd_t, rfd_link);
+	priv->rx_head = ether1_inw (dev, priv->rx_head, rfd_t, rfd_link, NORMALIRQS);
     } while (1);
 }
 
@@ -898,10 +926,10 @@
 
     dev->interrupt = 1;
 
-    status = ether1_inw (dev, SCB_ADDR, scb_t, scb_status);
+    status = ether1_inw (dev, SCB_ADDR, scb_t, scb_status, NORMALIRQS);
     if (status ) {
 	ether1_outw (dev, status & (SCB_STRNR | SCB_STCNA | SCB_STFR | SCB_STCX),
-			SCB_ADDR, scb_t, scb_command);
+			SCB_ADDR, scb_t, scb_command, NORMALIRQS);
 	outb (CTRL_CA | CTRL_ACK, REG_CONTROL);
 	if (status & SCB_STCX) {
 	    ether1_xmit_done (dev);
@@ -909,8 +937,9 @@
 	if (status & SCB_STCNA) {
 	    if (priv->resetting == 0)
 		printk ("%s: CU went not ready ???\n", dev->name);
-	    if (ether1_inw (dev, SCB_ADDR, scb_t, scb_cbl_offset) != (unsigned short)I82586_NULL) {
-		ether1_outw (dev, SCB_CMDCUCSTART, SCB_ADDR, scb_t, scb_command);
+	    if (ether1_inw (dev, SCB_ADDR, scb_t, scb_cbl_offset, NORMALIRQS)
+				!= (unsigned short)I82586_NULL) {
+		ether1_outw (dev, SCB_CMDCUCSTART, SCB_ADDR, scb_t, scb_command, NORMALIRQS);
 		outb (CTRL_CA, REG_CONTROL);
 	    }
 	    if (priv->resetting == 2)
@@ -921,7 +950,8 @@
 	}
 	if (status & SCB_STRNR) {
 	    printk ("%s: RU went not ready\n", dev->name);
-	    printk ("RU ptr = %04X\n", ether1_inw (dev, SCB_ADDR, scb_t, scb_rfa_offset));
+	    printk ("RU ptr = %04X\n", ether1_inw (dev, SCB_ADDR, scb_t, scb_rfa_offset,
+					NORMALIRQS));
 	}
     } else
         outb (CTRL_ACK, REG_CONTROL);
diff -urN linux.store/linux/arch/arm/drivers/net/ether3.c linux/arch/arm/drivers/net/ether3.c
--- linux.store/linux/arch/arm/drivers/net/ether3.c	Tue Mar  5 13:04:29 1996
+++ linux/arch/arm/drivers/net/ether3.c	Mon Mar 11 22:35:09 1996
@@ -3,7 +3,7 @@
  *
  * SEEQ nq8005 ethernet driver
  *
- * By Russell King.
+ * By Russell King, with some suggestions from borris@ant.co.uk
  *
  * Changelog:
  *  29/02/96:	RMK	Won't pass packets that are from our ethernet address
@@ -182,7 +182,6 @@
 ether3_ramtest(struct device *dev, unsigned char byte)
 {
     unsigned char *buffer = kmalloc(RX_END, GFP_KERNEL);
-    unsigned long flags;
     int i,ret=0;
     int max_errors = 4;
     int bad=-1;
@@ -190,9 +189,6 @@
     if (!buffer)
 	return 1;
 
-    save_flags (flags);
-    cli ();
-
     memset (buffer, byte, RX_END);
     ether3_writebuffer (dev, buffer, 0, TX_END);
     ether3_writebuffer (dev, buffer+RX_START, RX_START, RX_LEN);
@@ -220,7 +216,6 @@
     if (bad != -1)
 	printk (" - 0x10000\n");
     kfree (buffer);
-    restore_flags (flags);
 
     return ret;
 }
@@ -462,8 +457,7 @@
     dev->tbusy = 1;
     dev->start = 0;
 
-    save_flags (flags);
-    cli ();
+    save_flags_cli (flags);
 
     outw (CMD_RXOFF|CMD_TXOFF, REG_COMMAND);
     priv->regs.command = 0;
@@ -583,8 +577,7 @@
 
 	thishdr |= htons (nextpacket);
 
-	save_flags(flags);
-	cli();
+	save_flags_cli (flags);
 	ether3_writebuffer(dev, skb->data, thisdata, (length & 1) ? (length + 1) : length);
 	ether3_writebuffer(dev, &nexthdr, -1, 4);
 	ether3_ledincrementuse (dev);
@@ -631,17 +624,20 @@
 
     	done = 0;
 	status = inw(REG_STATUS);
-	outw ((status & (STAT_INTRX|STAT_INTTX|STAT_INTBUFWIN))
-		| priv->regs.command, REG_COMMAND);
 
 	if (status & STAT_INTRX) { /* Got a packet(s). */
+	    outw (CMD_ACKINTRX | priv->regs.command, REG_COMMAND);
 	    ether3_rx (dev, priv);
 	    done = 1;
 	}
 	if (status & STAT_INTTX) { /* Packets transmitted */
+	    outw (CMD_ACKINTTX | priv->regs.command, REG_COMMAND);
 	    ether3_tx (dev, priv);
 	    done = 1;
 	}
+	if (status & STAT_INTBUFWIN) { /* buffer window interrupt */
+	    outw (CMD_ACKINTBUFWIN | priv->regs.command, REG_COMMAND);
+	}
     } while (-- boguscount && !done) ;
 
     dev->interrupt = 0;
@@ -685,10 +681,8 @@
 	prev_recv_ptr = current_recv_ptr;
 	ether3_readbuffer (dev, &p, current_recv_ptr, 16);
 
-	if ((p.rxhdr & RX_NEXT) == 0 || (p.rxhdr & RXSTAT_DONE) == 0
-		|| (p.rxhdr & (RXHDR_CHAINCONTINUE|RXHDR_RECEIVE)) != RXHDR_CHAINCONTINUE)
+	if ((p.rxhdr & RX_NEXT) == 0 || (p.rxhdr & RXSTAT_DONE) == 0)
 	    break;
-
 	current_recv_ptr = ntohs (p.rxhdr & RX_NEXT);
 
 	/*
@@ -696,7 +690,10 @@
  	 */
 	if (memcmp (dev->dev_addr, &p.src_addr, 6) == 0) {
 	    outw (current_recv_ptr >> 8, REG_RECVEND);
-	    continue;
+	    if (p.rxhdr & RXHDR_CHAINCONTINUE)
+		continue;
+	    else
+		break;
 	}
 
 	if (p.rxhdr & (RXSTAT_OVERSIZE|RXSTAT_CRCERROR|RXSTAT_DRIBBLEERROR|RXSTAT_SHORTPACKET)) {
@@ -706,7 +703,10 @@
 	    if(p.rxhdr & RXSTAT_DRIBBLEERROR) priv->stats.rx_fifo_errors ++;
 	    if(p.rxhdr & RXSTAT_SHORTPACKET) priv->stats.rx_length_errors ++;
 	    outw (current_recv_ptr >> 8, REG_RECVEND);
-	    continue;
+	    if (p.rxhdr & RXHDR_CHAINCONTINUE)
+		continue;
+	    else
+		break;
 	}
 
 	if (current_recv_ptr > prev_recv_ptr)
@@ -742,6 +742,8 @@
 	skb->protocol = eth_type_trans(skb, dev);
 	netif_rx (skb);
 	priv->stats.rx_packets++;
+	if (!(p.rxhdr & RXHDR_CHAINCONTINUE))
+	    break;
     }
     while (-- maxcnt);
 
diff -urN linux.store/linux/arch/arm/drivers/scsi/Makefile linux/arch/arm/drivers/scsi/Makefile
--- linux.store/linux/arch/arm/drivers/scsi/Makefile	Sat Feb 24 13:17:59 1996
+++ linux/arch/arm/drivers/scsi/Makefile	Wed Mar 13 22:57:35 1996
@@ -122,10 +122,10 @@
 	$(LD) $(LD_RFLAG) -r -o $@ sd.o sd_ioctl.o
 
 oak_mod.o: oak.o
-	$(LD) $(LD_RFLAG) -r -o oak_mod.o oak.o `gcc --print-libgcc-file-name`
+	$(LD) $(LD_RFLAG) -r -o oak_mod.o oak.o $(GCCLIB)
 
 acornscsi_mod.o: acornscsi.o acornscsi-io.o
-	$(LD) $(LD_RFLAG) -r -o acornscsi_mod.o acornscsi.o acornscsi-io.o `gcc --print-libgcc-file-name`
+	$(LD) $(LD_RFLAG) -r -o acornscsi_mod.o acornscsi.o acornscsi-io.o $(GCCLIB)
 
 $(SYMTAB_OBJS): $(SYMTAB_OBJS:.o=.c)
 
diff -urN linux.store/linux/arch/arm/drivers/scsi/acornscsi.c linux/arch/arm/drivers/scsi/acornscsi.c
--- linux.store/linux/arch/arm/drivers/scsi/acornscsi.c	Sun Feb 11 09:32:31 1996
+++ linux/arch/arm/drivers/scsi/acornscsi.c	Mon Mar 11 22:35:55 1996
@@ -785,8 +785,7 @@
 
     dmac_write (instance, MASKREG, MASK_ON);
 
-    save_flags (flags);
-    cli ();
+    save_flags_cli (flags);
     ascmd = hostdata->connected;
     hostdata->connected = NULL;
 
diff -urN linux.store/linux/arch/arm/kernel/Makefile linux/arch/arm/kernel/Makefile
--- linux.store/linux/arch/arm/kernel/Makefile	Sun Feb 11 09:32:37 1996
+++ linux/arch/arm/kernel/Makefile	Wed Mar 13 14:32:05 1996
@@ -17,6 +17,10 @@
 	    ioport.o arm.o setup.o time.o ecard.o sys-arm.o \
 	    dma.o
 
+ifeq ($(MACHINE),arc)
+  O_OBJS += oldlatches.o
+endif
+
 head.o: head.S $(TOPDIR)/include/linux/tasks.h
 	$(CC) -D__ASSEMBLY__ -traditional -c $*.S -o $*.o
 
diff -urN linux.store/linux/arch/arm/kernel/dma.c linux/arch/arm/kernel/dma.c
--- linux.store/linux/arch/arm/kernel/dma.c	Sun Mar  3 13:02:49 1996
+++ linux/arch/arm/kernel/dma.c	Wed Mar 13 14:53:17 1996
@@ -15,6 +15,7 @@
 
 void enable_dma (unsigned int dmanr)
 {
+#ifdef CONFIG_BLK_DEV_FD
     if (dmanr == 2) {
     	switch (dma_direction[dmanr]) {
     	case 1: /* read */
@@ -42,8 +43,72 @@
     	default:
 	    printk ("enable_dma: dma%d not initialised\n", dmanr);
 	    return;
-	}
-    }
+	} /* Direction switch */
+    }; /* dmanr == 2 */
+#endif
+#ifdef CONFIG_BLK_DEV_FD1772
+    switch (dmanr) {
+      case 0: /* Data DMA */
+		switch (dma_direction[dmanr]) {
+		case 1: /* read */
+    	    	{
+			extern unsigned char fdc1772_dma_read, fdc1772_dma_read_end;
+			extern void fdc1772_setupdma(unsigned int count,unsigned int addr);
+			unsigned long flags;
+
+      /*printk("enable_dma fdc1772 data read\n");*/
+			save_flags(flags);
+			cliIF();
+			
+			memcpy ((void *)0x1c, (void *)&fdc1772_dma_read,
+				&fdc1772_dma_read_end - &fdc1772_dma_read);
+			fdc1772_setupdma(dma_count[dmanr],dma_address[dmanr]); /* Sets data pointer up */
+			enable_irq (16);
+			restore_flags(flags);
+		}
+		break;
+
+		case 0: /* write */
+	        {
+			extern unsigned char fdc1772_dma_write, fdc1772_dma_write_end;
+			extern void fdc1772_setupdma(unsigned int count,unsigned int addr);
+			unsigned long flags;
+
+      /*printk("enable_dma fdc1772 data write\n");*/
+			save_flags(flags);
+			cliIF();
+			memcpy ((void *)0x1c, (void *)&fdc1772_dma_write,
+				&fdc1772_dma_write_end - &fdc1772_dma_write);
+			fdc1772_setupdma(dma_count[dmanr],dma_address[dmanr]); /* Sets data pointer up */
+			enable_irq (16);
+
+			restore_flags(flags);
+		}
+		break;
+
+    		default:
+		    printk ("enable_dma: dma%d not initialised\n", dmanr);
+		    return;
+	} /* DMA direction switch */
+        break;
+
+      case 1: /* Command end FIQ - actually just sets a flag */
+      {
+	/* Need to build a branch at the FIQ address */
+	extern void fdc1772_comendhandler(void);
+	unsigned long flags;
+
+  /*printk("enable_dma fdc1772 command end FIQ\n");*/
+	save_flags(flags);
+	cliIF();
+	
+	*((unsigned int *)0x1c)=0xea000000 | (((unsigned int)fdc1772_comendhandler-(0x1c+8))/4); /* B fdc1772_comendhandler */
+
+	restore_flags(flags);
+      };
+      break;
+    } /* dma number switch */
+#endif
 }
 
 void set_dma_mode (unsigned int dmanr, char mode)
@@ -79,9 +144,15 @@
 
 int get_dma_residue (unsigned int dmanr)
 {
+#ifdef CONFIG_BLK_DEV_FD
     extern int floppy_fiqresidual (void);
     if (dmanr == 2)
 	return floppy_fiqresidual ();
+#endif
+#ifdef CONFIG_BLK_DEV_FD1772
+    extern unsigned int fdc1772_bytestogo;
+    if (dmanr == 0) return fdc1772_bytestogo; 
+#endif
 
     return -1;
 }
